use std::sync::mpsc;

pub struct Signal {
    receiver:mpsc::Receiver<()>,
    sender:mpsc::Sender<()>,
}
impl Signal {
    pub fn new() -> Self
    {
        let (sender, receiver) = mpsc::channel::<()>();
        Self {
            receiver:receiver,
            sender:sender,
        }
    }

    pub fn wait(&self)
    {
        self.receiver.recv().ok();
    }

    pub fn register(&self) -> mpsc::Sender<()>
    {
        self.sender.clone()
    }
}
